﻿Option Explicit On
Imports Microsoft.DirectX
Imports Microsoft.DirectX.DirectSound
Module DSound
    'Public DX As DirectX9

    'Public DirectSound_Enum As Enum
    Private Sound_Device As New Device
    Public Sound_Buffer As SecondaryBuffer
    Private Sound_Buffer_Description As New DirectSound.BufferDescription()
    Public Sound_Buffer_Wave_Format As New WaveFormat()

    Public Const MAX_VOLUME As Long = 100
    Public Buffer_Length As Long, Half_Buffer_Length As Long
    Public Buffer_Size As Long
    Public Sound_Data() As Byte
    Public Sub DirectSound_Initialize()

        'DX = New DirectSound
        'DirectSound_Enum = DX.GetDSEnum
        'DirectSound = DX.DirectSoundCreate(DirectSound_Enum.GetGuid(1))

        With Sound_Buffer_Wave_Format
            .FormatTag = WaveFormatTag.Pcm
            .Channels = 1 '1 = Mono   2 = Stereo. The NES is Mono
            .BitsPerSample = 16
            .SamplesPerSecond = 44100 '22050
            .BlockAlign = (.BitsPerSample * .Channels) / 8
            .AverageBytesPerSecond = ((.BitsPerSample / 8) * .Channels) * .SamplesPerSecond

            Buffer_Size = .AverageBytesPerSecond '* 5
            ReDim Sound_Data(Buffer_Size)

            Half_Buffer_Length = .AverageBytesPerSecond / 2 '/ 15
            Half_Buffer_Length = Half_Buffer_Length + (Half_Buffer_Length Mod .BlockAlign)
        End With

        Buffer_Length = Half_Buffer_Length * 2

        Sound_Device.SetCooperativeLevel(Form1.Handle, CooperativeLevel.Normal)

        With Sound_Buffer_Description
            .Format = Sound_Buffer_Wave_Format
            .BufferBytes = Buffer_Length
            'DSBCAPS_STICKYFOCUS - means it will keep playing even if our application does not have focus
            .Flags = BufferDescriptionFlags.ControlPositionNotify Or _
                      BufferDescriptionFlags.StickyFocus Or _
                      BufferDescriptionFlags.ControlFrequency Or _
                      BufferDescriptionFlags.ControlPan Or _
                      BufferDescriptionFlags.ControlVolume
        End With

        Sound_Buffer = New SecondaryBuffer(Sound_Buffer_Description, Sound_Device)
        'DirectSound.CreateSoundBuffer(Sound_Buffer_Description)
        Sound_Channel_Clear_Buffer()
        Set_Sound_Volume(Sound_Buffer, 100)
        Play_Sound_Loop(Sound_Buffer)
        'Sound_Buffer.Play(0, DirectSound.BufferPlayFlags.Looping)
    End Sub
    Public Sub Play_Sound(ByVal Sound_Buffer As SecondaryBuffer)
        Sound_Buffer.SetCurrentPosition(0)
        Sound_Buffer.Play(0, BufferPlayFlags.Default)
    End Sub
    Public Sub Play_Sound_Once(ByVal Sound_Buffer As SecondaryBuffer)
        Sound_Buffer.Play(0, BufferPlayFlags.Default)
    End Sub
    Public Sub Play_Sound_Loop(ByVal Sound_Buffer As SecondaryBuffer)
        Sound_Buffer.Play(0, BufferPlayFlags.Looping)
    End Sub
    Public Sub Pause_Sound(ByVal Sound_Buffer As SecondaryBuffer)
        Sound_Buffer.Stop()
    End Sub
    Public Sub Set_Sound_Volume(ByVal Buffer As SecondaryBuffer, ByVal Volume As Long)
        If Volume >= MAX_VOLUME Then Volume = MAX_VOLUME
        If Volume <= 0 Then Volume = 0
        Buffer.Volume = ((Volume / MAX_VOLUME) * 10000) + -10000
    End Sub
    Public Sub DirectSound_Shutdown()
        'Sound_Buffer = Nothing
        'DirectSound_Enum = Nothing
        'DirectSound = Nothing
    End Sub
End Module
